'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _find2 = require('lodash/find');

var _find3 = _interopRequireDefault(_find2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (WrappedComponent) {
    var _class, _temp2;

    return _temp2 = _class = function (_Component) {
        _inherits(_class, _Component);

        function _class() {
            var _ref;

            var _temp, _this, _ret;

            _classCallCheck(this, _class);

            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                args[_key] = arguments[_key];
            }

            return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = _class.__proto__ || Object.getPrototypeOf(_class)).call.apply(_ref, [this].concat(args))), _this), _this.getRequestTools = function () {
                var store = _this.context.store;

                var composeRequestQuery = function composeRequestQuery(check) {
                    return function (requestString, resolve, reject) {
                        var result = check(requestString);
                        var format = function format(data) {
                            return typeof data === 'function' ? data() : typeof data === 'undefined' ? null : data;
                        };

                        if (result) return format(resolve);
                        return format(reject);
                    };
                };

                var getRequest = function getRequest(func) {
                    return function (idOrName) {
                        var _store$getState = store.getState(),
                            requests = _store$getState.requests;

                        var request = (0, _find3.default)(requests, function (request) {
                            return request.id == idOrName || request.name == idOrName;
                        });
                        return func(request);
                    };
                };

                return {
                    isComplete: composeRequestQuery(getRequest(function (request) {
                        return request && request.status != "pending";
                    })),
                    wasSuccessful: composeRequestQuery(getRequest(function (request) {
                        return request && request.status == "complete";
                    })),
                    didFail: composeRequestQuery(getRequest(function (request) {
                        return request && request.status == "failed";
                    })),
                    isPending: composeRequestQuery(getRequest(function (request) {
                        return request && request.status == "pending";
                    }))
                };
            }, _temp), _possibleConstructorReturn(_this, _ret);
        }

        _createClass(_class, [{
            key: 'render',
            value: function render() {
                return _react2.default.createElement(WrappedComponent, _extends({}, this.props, this.getRequestTools()));
            }
        }]);

        return _class;
    }(_react.Component), _class.contextTypes = {
        store: _react.PropTypes.object
    }, _temp2;
};